#!/usr/bin/perl -w
require "/home/psybercore/superscripts.com/htdocs/test/0/Net/ParseWhois.pm";
#use lib('lib');
##################################################
# MAIN ROUTINE
##################################################
open (DOMAINLIST, "domains");
flock(DOMAINLIST, 2);
@domains=<DOMAINLIST>;
flock(DOMAINLIST, 8);
close DOMAINLIST;

foreach $domains(@domains){
chomp $domains;
$dom = $domains;
print "PARSING $dom...<br>\n";
&parsedomain;
}
exit;
open (RAWWHOISOUTPUT, ">temp");
close RAWWHOISOUTPUT;
open (CLEANWHOISOUTPUT, ">piped");
close CLEANWHOISOUTPUT;
&parsedomain;
print "FINISHED";
exit;

sub parsedomain{
##################################################
# SETUP & ERROR CHECK
##################################################
my $w = Net::ParseWhois::Domain->new($dom, { debug => 0 });
unless (defined $w) { die "Can't connect to Whois server - $w\n";}
unless ($w->ok) {
	die "No match for $dom\n";
	}
if ($w->unknown_registrar) {
	die "domain found, registrar unknown. raw data follows\n" . $w->raw_whois_text . "\n";
	}

##################################################
# GET BASIC INFO
##################################################
open (RAWWHOISOUTPUT, ">temp");
flock(RAWWHOISOUTPUT, 2);
##################################################
# GET BASIC INFO
##################################################
print RAWWHOISOUTPUT $w->domain, "|";
print RAWWHOISOUTPUT "|";
print RAWWHOISOUTPUT $w->registrar, "|";
print RAWWHOISOUTPUT "|";
print RAWWHOISOUTPUT $w->name, "|";
print RAWWHOISOUTPUT "|";
print RAWWHOISOUTPUT $w->tag, "|";
print RAWWHOISOUTPUT "|";
print RAWWHOISOUTPUT map { "    $_|" } $w->address;
print RAWWHOISOUTPUT "|";
print RAWWHOISOUTPUT $w->country, "|";
print RAWWHOISOUTPUT "|";
##################################################
# GET CONTACTS
##################################################
my ($c, $t);
if ($c = $w->contacts) {
  for $t (sort keys %$c) {
    print RAWWHOISOUTPUT "    $t:";
    print RAWWHOISOUTPUT map { "\t$_|" } @{$$c{$t}};
  }
}
##################################################
# GET NAME SERVERS
##################################################
print RAWWHOISOUTPUT map {"$$_[0] ($$_[1])|"}@{$w->servers};
##################################################
# CLOSETEMPFILE
##################################################
flock(WHOISOUTPUT, 8);
close WHOISOUTPUT;
##################################################
# CLEANUP
##################################################
open (RAWWHOISOUTPUT, "temp");
flock(RAWWHOISOUTPUT, 2);
@whoisrawdata = <RAWWHOISOUTPUT>;
flock(RAWWHOISOUTPUT, 8);
close RAWWHOISOUTPUT;

open (CLEANWHOISOUTPUT, ">>piped");
flock(CLEANWHOISOUTPUT, 2);
$whoisdata = $whoisrawdata[0];

$whoisdata =~ tr/a-z/A-Z/;
$whoisdata =~ s/\,//g;
$whoisdata =~ s/ /*/g;
$whoisdata =~ s/\s/||/g;
$whoisdata =~ s/\(/|/g;
$whoisdata =~ s/\)/|/g;
$whoisdata =~ s/\*/ /g;
$whoisdata =~ s/\| /\|/g;
$whoisdata =~ s/\| /\|/g;
$whoisdata =~ s/\| /\|/g;
$whoisdata =~ s/\| /\|/g;
$whoisdata =~ s/\| /\|/g;
$whoisdata =~ s/\| /\|/g;

$whoisdata =~ s/ \|/\|/g;
$whoisdata =~ s/ \|/\|/g;
$whoisdata =~ s/ \|/\|/g;
$whoisdata =~ s/ \|/\|/g;
$whoisdata =~ s/ \|/\|/g;

$whoisdata =~ s/TECHNICAL\://g;
$whoisdata =~ s/BILLING\://g;
$whoisdata =~ s/ADMINISTRATIVE\://g;

(@chunks)=split(/\|/,$whoisdata);
foreach $chunks(@chunks){
print CLEANWHOISOUTPUT "$chunks|" unless ($chunks eq "");
}
print CLEANWHOISOUTPUT "\n";
flock(CLEANWHOISOUTPUT, 8);
close CLEANWHOISOUTPUT;
##################################################
}
